#ifndef __ET_TOKEN_H__
#define __ET_TOKEN_H__

#include "rsa.h"
#include "des.h"
#include "My_C51.h"
#include "usb.h"
#include "usbi.h"


#define MAX_PACKET_SIZE		1024
#define HID_BUFF_SIZE		  58
#define APDU_COMMAND_SIZE	   6


//Ͳӿ
#define APDU_INS_VERFY_PIN			0x20     //УPIN
#define APDU_INS_CHANGE_PIN			0x24     //PIN
#define APDU_INS_SET_ATR		    0x25     //ATR
#define APDU_INS_SET_SHELL_KEY		0x30     //KEY
#define APDU_INS_GEN_RSA_KEY		0x46     //RSA KEY
#define APDU_INS_GET_KEY			0x47     //ȡͨѶԿ
#define APDU_INS_LED_CONTROL		0x50     //LED

#define APDU_INS_CHANGE_DIR			0xA4     //ĵǰĿ¼

#define APDU_INS_GET_DEVICE_INFO	0xCA     //ȡ豸Ϣ
#define APDU_INS_SET_CUSTOMER		0xCB     //ÿͻ
#define APDU_INS_GET_CUSTOMER		0xCC     //ȡͻ
#define APDU_INS_GET_FOLDER_INFO	0xCD     //ȡļϢ
#define APDU_INS_GET_FILE_INFO		0xCE     //ȡļϢ
#define APDU_INS_EXECUTE		    0xCF     //ִļ
#define APDU_INS_WRITE_FILE			0xD6     //дļ
#define APDU_INS_CREATE_FOLDER		0xE0     //ļ
#define APDU_INS_CREATE_FILE		0xE1     //ļ
#define APDU_INS_RESET_DEVICE		0xE3     //λ豸
#define APDU_INS_CLEAR_DIR			0xE4     //ļ
#define APDU_INS_SET_TOKEN_TYPE		0xE7     //token

#define ET199_DEV_PIN_LEN			24
#define ET199_USER_PIN_LEN			 8
#define ET199_MAX_ATR_LEN			16
#define ET199_E_LEN					 4

#define ET_USER_PIN					 0       //û  PIN
#define ET_DEV_PIN					 1       //PIN

#define	  ET_DEFAULT_DEV_PIN		(unsigned char *)"123456781234567812345678"
#define   ET_DEFAULT_USER_PIN		(unsigned char *)"12345678"


#define STRUCT_COS_TLV_(Tlv_Length)	            \
struct								            \
{									            \
	unsigned char bTagHigh;					            \
	unsigned char bTagLow;					            \
	unsigned char bLenHigh;					            \
	unsigned char bLenLow;					            \
	unsigned char bData[Tlv_Length];			            \
}

#define STRUCT_COS_RSA_PUBLIC_KEY_(Bits)        \
struct									        \
{										        \
	STRUCT_COS_TLV_(Bits/8)		n;		        \
	STRUCT_COS_TLV_(4)			e;		        \
}

typedef STRUCT_COS_RSA_PUBLIC_KEY_(1024)	COS_RSA_PUBLIC_KEY_1024;

#define STRUCT_COS_RSA_CRT_PRIVATE_KEY_(Bits)	\
struct											\
{												\
	STRUCT_COS_TLV_(Bits/16)	p;				\
	STRUCT_COS_TLV_(Bits/16)	q;				\
	STRUCT_COS_TLV_(Bits/16)	dp;				\
	STRUCT_COS_TLV_(Bits/16)	dq;				\
	STRUCT_COS_TLV_(Bits/16)	InvQ;			\
}

typedef STRUCT_COS_RSA_CRT_PRIVATE_KEY_(1024)	COS_RSA_CRT_PRIVATE_KEY_1024;

#define STRUCT_COS_RSA_PRIVATE_KEY_(Bits)		\
struct											\
{												\
	STRUCT_COS_TLV_(Bits/8)	n;					\
	STRUCT_COS_TLV_(Bits/8)	d;					\
}

typedef STRUCT_COS_RSA_PRIVATE_KEY_(1024)	COS_RSA_PRIVATE_KEY_1024;

struct ET_Device_Descript
{
	char	  device_path[256];
	struct usb_device*  dev;
	usb_dev_handle*	device_handle;
	unsigned short	  ver;
	unsigned char      custom[4];
	unsigned char      sn[8];
	unsigned char      key[8];
	char    IsChecked;
	unsigned char      tmpdevpin[24];
	unsigned char  endPoint[2];
};



struct APDUEx
{
	unsigned char		cla;
	unsigned char		ins;
	unsigned char		p1;
	unsigned char		p2;
	unsigned char		p3;
	unsigned char		p4;
	unsigned char		buffer[MAX_PACKET_SIZE];
	unsigned short		sendlen;
	unsigned short		recvlen;
} ;

struct ET199_HID_BUFFER
{
 	//unsigned char id;
	unsigned char uc0PacketSizeH;   //  ݰ_ֽ
    unsigned char uc1PacketSizeL;   //  ݰ_ֽ
                                    // 
    unsigned char uc2BlockOffsetH;  //  ݿƫ_ֽ
    unsigned char uc3BlockOffsetL;  //  ݿƫ_ֽ
                                    // 
    unsigned char uc4BlockSizeH;    //  ݿ鳤_ֽ
    unsigned char uc5BlockSizeL;    //  ݿ鳤_ֽ
                                    
    unsigned char uc6Buffer[HID_BUFF_SIZE];//  ݿ
};  

struct HID_Error
{
	unsigned char  sw1;
	unsigned char  sw2;
	unsigned int error_code;
} ;


//===========================
//#pragma pack(1)

struct CREATE_DIR
{
	unsigned char	FileID_L;
	unsigned char	FileID_H;
	unsigned char	SpaceSize_L;
	unsigned char	SpaceSize_M;
	unsigned char	SpaceSize_H;
};

struct CHANGE_DEV_PIN
{
	unsigned char	OldPinLen;
	unsigned char	OldPin[ET199_DEV_PIN_LEN];
	unsigned char	NewPinLen;
	unsigned char	NewPin[ET199_DEV_PIN_LEN];
	unsigned char	TryCount;
};

struct CHANGE_USER_PIN
{
	unsigned char	OldPinLen;
	unsigned char	OldPin[ET199_USER_PIN_LEN];
	unsigned char	NewPinLen;
	unsigned char	NewPin[ET199_USER_PIN_LEN];
	unsigned char	TryCount;
};

struct WRITE_FILE
{
	unsigned char	OffsetL;
	unsigned char	OffsetH;
	unsigned char	LengthL;
	unsigned char	LengthH;
	unsigned char	Data;     //unsigned char	Data[0];
};

struct CREATE_FILE
{
	unsigned char	FileID_L;
	unsigned char	FileID_H;
	unsigned char	SpaceSize_L;
	unsigned char	SpaceSize_H;
	unsigned char	FileType;
};

struct DEVICE_INFO
{
	unsigned char	TokenType;
	unsigned char	DongleType;
	unsigned char	VersionHigh;
	unsigned char	VersionLow;
	unsigned char	ATR[ET199_MAX_ATR_LEN];
	unsigned char	Date[6];	
	unsigned char	HardSerial[8];
	union
	{
		struct
		{
			unsigned char	TokenSpaceL;
			unsigned char	TokenSpaceM1;
			unsigned char	TokenSpaceM2;
			unsigned char	TokenSpaceH;
		};
		unsigned int TokenSpace;
	};
};

struct DIR_INFO
{
	union
	{
		struct
		{
			unsigned char	DirSpaceL;
			unsigned char	DirSpaceM1;
			unsigned char	DirSpaceM2;
			unsigned char	DirSpaceH;
		};
		unsigned int DirSpace;
	};	
	union
	{
		struct
		{
			unsigned char	DirUsableSpaceL;
			unsigned char	DirUsableSpaceM1;
			unsigned char	DirUsableSpaceM2;
			unsigned char	DirUsableSpaceH;
		};
		unsigned int DirUsableSpace;
	};
	unsigned char	byMaxUPTryCount;
	unsigned char	byRemainUPTryCount;
	unsigned char	byMaxSPTryCount;
	unsigned char	byRemainSPTryCount;
};

struct FILE_INFO
{
	unsigned char	byFileType;
	unsigned char	byFileSizeL;
	unsigned char	byFileSizeH;
};

struct GEN_RSA_KEY
{
	unsigned char	byPubFileIDL;
	unsigned char	byPubFileIDH;
	unsigned char	byPriFileIDL;
	unsigned char	byPriFileIDH;
	unsigned char	byKeyType;
	unsigned char	byELen;
	unsigned char	byE[ET199_E_LEN];
};


//method

		
    //===========================================
	unsigned long ET_Find(unsigned char* pid, int* count);
	unsigned long ET_Open(struct ET_Device_Descript* pHandle);
	unsigned long ET_GetPID(struct ET_Device_Descript* pHandle, unsigned char* pid);
	unsigned long ET_SetPID(struct ET_Device_Descript* pHandle, unsigned char* pucSeed, int SeedLen);
	unsigned long ET_Close(struct ET_Device_Descript* pHandle, char IsReset);
	
	unsigned long ET_GetHSN(struct ET_Device_Descript* pHandle, unsigned char* sn);
	unsigned long ET_GenRandom(struct ET_Device_Descript* pHandle, int len_need, unsigned char* pOutbuf);
	unsigned long ET_GetFreeSize(struct ET_Device_Descript* pHandle, int* pSize);
	unsigned long ET_LedCtrl(struct ET_Device_Descript* pHandle, int flag);
	
	unsigned long ET_VerifyDevPIN(struct ET_Device_Descript* pHandle, unsigned char* pInPIN, int len, int* pRemainCount);
	unsigned long ET_ChangeDevPIN(struct ET_Device_Descript* pHandle, unsigned char* pOldPin, int OldPin_len, unsigned char* pNewPin, int NewPin_len, int TryCount);
		
	unsigned long ET_Read(struct ET_Device_Descript* pHandle, int offset,int len, unsigned char* pucReadBuf);
	unsigned long ET_Write(struct ET_Device_Descript* pHandle, int offset,int len, unsigned char* pucWriteBuf);
	unsigned long ET_VendorWrite(struct ET_Device_Descript* pHandle, int offset,int len, unsigned char* pucWriteBuf);
	
	unsigned long ET_ReadShare(struct ET_Device_Descript* pHandle, int offset,int len, unsigned char* pucReadBuf);
	unsigned long ET_WriteShare(struct ET_Device_Descript* pHandle, int offset,int len, unsigned char* pucWriteBuf);
			
	unsigned long ET_CreateFile(struct ET_Device_Descript* pHandle, unsigned short FileID, int Size, int Type);
	unsigned long ET_WriteFile(struct ET_Device_Descript* pHandle, unsigned short FileID, int offset, unsigned char* pbuf, int Size);
	unsigned long ET_ExecuteFile(struct ET_Device_Descript* pHandle, unsigned short FileID, unsigned char* pInBuf, int InSize, unsigned char* pOutBuf, int* pOutSize, char IsServer);
	unsigned long ET_EraseAllFile(struct ET_Device_Descript* pHandle);
	
	unsigned long ET_GenRsaKey(struct ET_Device_Descript* pHandle, int kid, unsigned char* pPubBakup, unsigned char* pPriBakup);
	unsigned long ET_SetRsaKey(struct ET_Device_Descript* pHandle, int kid, unsigned char* pPubKey, unsigned char* pPriKey);
	unsigned long ET_PublicEncrypt(struct ET_Device_Descript* pHandle, int kid, unsigned char* pBuf, int len);
	unsigned long ET_PrivateDecrypt(struct ET_Device_Descript* pHandle, int kid, unsigned char* pBuf, int len);	
	unsigned long ET_MD5(struct ET_Device_Descript* pHandle, unsigned char* pBuf, int len, unsigned char* pMD5);
	unsigned long ET_SHA1(struct ET_Device_Descript* pHandle, unsigned char* pBuf, int len, unsigned char* pSHA1);
	unsigned long ET_SetESKey(struct ET_Device_Descript* pHandle, int kid, unsigned char* pKey);
	unsigned long ET_3DES(struct ET_Device_Descript* pHandle, int kid, int flag, unsigned char* pInBuf, int len);
		
	unsigned long ET_Update(struct ET_Device_Descript* pHandle, unsigned char* pbuf, int len);
	unsigned long ET_GenUpdatePacket(struct ET_Device_Descript* pHandle, unsigned char* pSN, int type, int kid, unsigned char* pbuf, int len, unsigned char* pUPubKey, unsigned char* pOutData, int* pOutLen);
    
	

	void  GetCpuID(unsigned char* pbuf);
	void  GetNameAndIp(char* pbuf);
	void  GetMacAddr(char* pbuf);

    unsigned long  EntToUser(struct ET_Device_Descript* pHandle);
	unsigned long  RetToRoot(struct ET_Device_Descript* pHandle);

//	unsigned long CheckDeviceCapabilities(HANDLE DeviceHandle);
    unsigned long ErrorCodeConvert(unsigned char sw1, unsigned char sw2);
    unsigned long TransmitHID(struct ET_Device_Descript* pHandle, struct APDUEx* apdu);
	unsigned long InitCommKey(struct ET_Device_Descript* pHandle);
    unsigned long GetDeviceInfo(struct ET_Device_Descript* pHandle, struct DEVICE_INFO* pDeviceInfo);
    unsigned long ApduWriteFile(struct ET_Device_Descript* pHandle, unsigned short FileID, int offset, unsigned char* pbuf, int len);
    
	unsigned long ET_WriteMachine(struct ET_Device_Descript* pHandle, unsigned char* pucWriteBuf);
	void  GetMachineMD5(unsigned char* pmd5);

    void  Xor(unsigned char* src, unsigned char* dst, int len);
    void  CommDesEnc(unsigned char* src, unsigned char* dst, unsigned char* key, int Len);
    void  CommDesDec(unsigned char* src, unsigned char* dst, unsigned char* key, int Len);
	
	void  ReverseBuffer(unsigned char* pInData, int len);	
	unsigned long ReverseDWORD(unsigned int dwData);
	void  UniCode2String(char* buffer);
	void  GetSoftRandom(unsigned char* pbuf);

	unsigned short  GetFileID(unsigned char type, unsigned char item);



#endif // __ET_TOKEN_H__
