#ifndef  __FT_MY_C51_HEADER_H
#define  __FT_MY_C51_HEADER_H

//#define	 machine		(unsigned char xdata *) 0x7B0

#define  ET_INVALID_MACHINE   0x00  //Machine Invalid
#define  Func_GetRandom       0x01  //Get Random
#define  Func_ReadData        0x02  //Read Data
#define  Func_WriteData       0x03  //Write Data
#define  Func_ReadShare       0x04  //Read Share Data
#define  Func_WriteShare      0x05  //Write Share Data
#define  Func_PublicEncrypt   0x06  //Public-key encryption
#define  Func_PrivateDecrypt  0x07  //Private-key encryption
#define  Func_MD5             0x08  //Md5 operations
#define  Func_SHA1            0x09  //SHA1 operations
#define  Func_3DES            0x0A //DES operations
#define  Func_AES             0x0B  //AES operations
#define  Func_Update          0x0C  //Update
#define  Func_WriteMachine    0x0D  //Write Machine into Share Memory

#define  File_Data            0x0001 //8192 byte Memory area

#define  File_Pub_1           0x0002 //140 Bytes Public-key 1
#define  File_Pub_2           0x0004 //140 Bytes Public-key 2
#define  File_Pub_3           0x0006 //140 Bytes Public-key 3
#define  File_Pub_4           0x0008 //140 Bytes Public-key 4
#define  File_Pub_5           0x000A //140 Bytes Public-key 5
#define  File_Pub_6           0x000C //140 Bytes Public-key 6
#define  File_Pub_7           0x000E //140 Bytes Public-key 7
#define  File_Pub_8           0x0010 //140 Bytes Public-key 8

#define  File_Pri_1           0x0003 //340 Bytes Private-key 1
#define  File_Pri_2           0x0005 //340 Bytes Private-key 2
#define  File_Pri_3           0x0007 //340 Bytes Private-key 3
#define  File_Pri_4           0x0009 //340 Bytes Private-key 4
#define  File_Pri_5           0x000B //340 Bytes Private-key 5
#define  File_Pri_6           0x000D //340 Bytes Private-key 6
#define  File_Pri_7           0x000F //340 Bytes Private-key 7
#define  File_Pri_8           0x0011 //340 Bytes Private-key 8

#define  File_Pub_up          0x0012 //140 Bytes Public-key for update
#define  File_Pri_up          0x0013 //340 Bytes Private-key for update

#define  File_Pub_com         0x0014 //140 Bytes Communicate Public-key
#define  File_Pri_com         0x0015 //340 Bytes Communicate Private-key

#define  File_Key_1           0x0016 //128 Byte File-key 1
#define  File_Key_2           0x0017 //128 Byte File-key 2
#define  File_Key_3           0x0018 //128 Byte File-key 3
#define  File_Key_4           0x0019 //128 Byte File-key 4
#define  File_Key_5           0x001A //128 Byte File-key 5
#define  File_Key_6           0x001B //128 Byte File-key 6
#define  File_Key_7           0x001C //128 Byte File-key 7
#define  File_Key_8           0x001D //128 Byte File-key 8

#define  File_C51EXE          0x001E //C51 Execute Interface

#define  FLAG_ENCODE          0
#define  FLAG_DECODE          1

//#pragma pack(1)

//Communicate Data
typedef struct _CommData
{
   unsigned char  m_zero;          //Set to Zero,Make RSA decryption normally
   unsigned char  m_action;        //Input is Fuction ID,Output is Return-value
   unsigned char  m_rand[8];       //Verify Random
   unsigned char  m_machine[16];   //Machine ID
   unsigned char  m_data[226];     //Data Packet
   
}CommData;

//===================================
//Func_GetRandom
typedef struct _Random_Param
{   
   unsigned char  m_len;           //Input Len (<=128)
   unsigned char  m_result[128];   //Return Value
} Random_Param;

//Func_ReadData or Func_WriteData
typedef struct _DataRW_Param
{        
   unsigned short  m_offset;        //offset
   unsigned char  m_len;           //Len (<=200)
   unsigned char  m_data[200];     //Input Date or Output Data
} DataRW_Param;

//Func_ReadShare or Func_WriteShare
typedef struct _ShareRW_Param
{         
   unsigned char  m_offset;        //offset
   unsigned char  m_len;           //Len (<=32)
   unsigned char  m_data[32];      //Data
} ShareRW_Param;

//Func_PublicEncrypt or Func_privateDecrypt
typedef struct _Rsa_Param
{   
   unsigned char  m_item;          //Key FileID
   unsigned char  m_data[128];     //128 Byte Plaintext data or Encrypted data
} Rsa_Param;

//Func_MD5 or Func_SHA1
typedef struct _Sign_Param
{    
   unsigned char  m_data[128];     //128 Bytes Input Data
   unsigned char  m_result[20];    //return result
} Sign_Param;

//Func_3DES or Func_AES
typedef struct _Enc_Param
{       
   unsigned char  m_item;          //key FileID
   unsigned char  m_flag;          //FLAG_ENCODE or FLAG_DECODE
   unsigned char  m_data[128];     //128 Bytes Input Data
} Enc_Param;

//Func_Update
typedef struct _Update_Param
{         
   unsigned char  reserve;         //Reserve,Must is Zero
   unsigned char  m_sn[8];         //SN, FFFFFFFFFFFFFFFF is not limit hardware ID
   unsigned char  m_type;          //0:Public-key File  1:Private-key File  2:Key File 3:8192 Bytes Data area
   unsigned char  m_item;          //(1-8)(M_item=3:ignore)
   unsigned short  m_offset;        //offset
   unsigned char  m_len;           //The length of the written data(<=114ֽ)
   unsigned char  m_data[114];     //114 Bytes Data Block
} Update_Param;


//Func_ReadMachine or Func_WriteMachine
typedef struct _Machine_Param
{  
   unsigned char  m_data[16];      //Data
} Machine_Param;

#endif	//__FT_MY_C51_HEADER_H
