#ifndef  __FT_RY3_HEADER_H
#define  __FT_RY3_HEADER_H

#ifdef __cplusplus
extern "C" {
#endif

typedef void*  RY_HANDLE;

//Error Code
#define   RY3_SUCCESS                       			0x00000000	//Success
#define   RY3_NOT_FOUND                     		0xF0000001	//Device not found
#define   RY3_INVALID_PARAMETER			0xF0000002	// Parameter error
#define   RY3_COMM_ERROR				0xF0000003	// Communicate error
#define   RY3_INSUFFICIENT_BUFFER		0xF0000004	// Buffer space is insufficient
#define   RY3_NO_LIST					    	0xF0000005	// Device list not found
#define   RY3_DEVPIN_NOT_CHECK			0xF0000006	//DEVPIN not verify
#define   RY3_USERPIN_NOT_CHECK			0xF0000007	// UserPIN not verify
#define	  RY3_RSA_FILE_FORMAT_ERROR	0xF0000008	// RSA File format error
#define   RY3_DIR_NOT_FOUND				0xF0000009	// Drectory not found
#define   RY3_ACCESS_DENIED				0xF000000A	// Access Denied
#define   RY3_ALREADY_INITIALIZED		    	0xF000000B	// Already Initialized
#define   RY3_INCORRECT_PIN				0xF0000C00	// Incorrect PIN
#define   RY3_DF_SIZE						0xF000000D	// Directory space is insufficient
#define   RY3_FILE_EXIST					0xF000000E	//File is exist
#define   RY3_UNSUPPORTED				0xF000000F	// Function does not support or Not build the file system
#define   RY3_FILE_NOT_FOUND			0xF0000010	//File not found
#define	  RY3_ALREADY_OPENED			0xF0000011	// Already Opened
#define   RY3_DIRECTORY_EXIST			0xF0000012	// Drectory Exist
#define   RY3_CODE_RANGE					0xF0000013	//Virtual machine Memory address overflow
#define   RY3_INVALID_POINTER			0xF0000014	//Vritual machine Wrong pointer
#define   RY3_GENERAL_FILESYSTEM			0xF0000015	// General file system error
#define   RY3_OFFSET_BEYOND				0xF0000016	// Offset beyond file size
#define   RY3_FILE_TYPE_MISMATCH			0xF0000017	// File Type Not Match
#define   RY3_PIN_BLOCKED				0xF0000018	//PIN locked
#define   RY3_INVALID_HANDLE				0xF0000019	// Invalid Handle
#define   RY3_ERROR_UNKNOWN			0xFFFFFFFF	// Unknown error


#define   RY3_C51_SUCCESS				0x00000000	//Success
#define   RY3_C51_UNKNOWN				0x00000001	//Unknown error
#define   RY3_C51_INVALID_PARAMETER	        0x00000002	//Parameter error
#define   RY3_C51_INVALID_ADDRESS		0x00000003	//Address error
#define   RY3_C51_INVALID_SIZE			0x00000004	//Size error
#define   RY3_C51_FILE_NOT_FOUND		0x00000005	//File not found
#define   RY3_C51_ACCESS_DENIED		        0x00000006	//Access Denied
#define   RY3_C51_FILE_SELECT			    	0x00000007	//The file open number has reached its maximum
#define   RY3_C51_INVALID_HANDLE		0x00000008	//Invalid Handle
#define   RY3_C51_FILE_OUT_OF_RANGE	        0x00000009	//Out of Range
#define   RY3_C51_FILE_TYPE_MISMATCH	0x0000000A	//File type not match
#define   RY3_C51_FILE_SIZE_MISMATCH	    	0x0000000B	//File size not match
#define   RY3_C51_NO_SPACE				0x0000000C	//Folder space isinsufficient
#define   RY3_C51_FILE_EXIST			    	0x0000000D	//File Exist
#define   RY3_C51_INVALID_KEY_FORMAT	0x0000000E	//Invalid key Format
#define   RY3_C51_KEY_LEN_MISMATCH		0x0000000F	//Key length not match
#define   RY3_C51_RSA_INVALID_KEY_FILE	0x00000010	//Invalid Key File
#define   RY3_C51_RSA_ENC_DEC_FAILED	0x00000011	//RSA Encrypt failed or decrypt failed
#define   RY3_C51_RSA_SIGN_VERI_FAILED	0x00000012	//	RSA Signature verification failed
#define   RY3_C51_SHA1					0x00000013	//  SHA1 Calculation errors
#define   RY3_C51_MD5					0x00000014	//  MD5 Calculation errors
#define   RY3_C51_INVALID_ADDERSS		0x00000015	//  Address error
#define   RY3_C51_EEPROM				    	0x00000016	// Write EEPROM error

//===============================================================================
//Find RY3 
unsigned long   RY3_Find(char* pVendorID, int* pCount);

//Open the designated RY3
unsigned long   RY3_Open(RY_HANDLE* pHandle, int Item);

//Close RY3
unsigned long   RY3_Close(RY_HANDLE handle, char IsReset);

//Set VendorID
unsigned long   RY3_SetVendorID(RY_HANDLE handle, char* pSeed, int len, char* pOutVendorID);

// Get HardID
unsigned long   RY3_GetHardID(RY_HANDLE handle, char* pbuf);

//Generation Random
unsigned long   RY3_GenRandom(RY_HANDLE handle, int len_need, unsigned char* pOutbuf);

//Get FreeSize
unsigned long   RY3_GetFreeSize(RY_HANDLE handle, int* pSize);

#define RY3_LED_ON		1	//light
#define RY3_LED_OFF		2	//lamp
#define RY3_LED_WINK	3	//twinkle

//LED  control
unsigned long   RY3_LEDControl(RY_HANDLE handle, int flag);

//Verify DevPIN
//Verify Success return: RemainCount=0
//Verify Failed return:RemainCount=0:locked 1-254: Surplus number  255:Unlimited
unsigned long   RY3_VerifyDevPin(RY_HANDLE handle, char* pInPin, int* pRemainCount);

//Change DevPIN(TryCount:1-255, 255:Unlimited)
unsigned long   RY3_ChangeDevPin(RY_HANDLE handle, char* pOldPin, char* pNewPin, int TryCount);

//Read Memory(0-8192 Bytes)
unsigned long   RY3_Read(RY_HANDLE handle, int offset, unsigned char* pOutbuf, int len);

//Write Memory(0-7168 Bytes)
unsigned long   RY3_Write(RY_HANDLE handle, int offset, unsigned char* pInbuf, int len);

//Vendor Write Memory(0-8192 Bytes)
unsigned long   RY3_VendorWrite(RY_HANDLE handle, int offset, unsigned char* pInbuf, int len);

//Read Share Memory(0-32 Bytes)
unsigned long   RY3_ReadShare(RY_HANDLE handle, int offset, unsigned char* pbuf, int len);

//Write Share Memory(0-32 Bytes)
unsigned long   RY3_WriteShare(RY_HANDLE handle, int offset, unsigned char* pbuf, int len);

#define FILE_TYPE_EXE			0	//Executable file
#define FILE_TYPE_DATA			1	//Data file
#define FILE_TYPE_RSA_PUBLIC		2	//RSA Public-key File
#define FILE_TYPE_RSA_PRIVATE	3	//RSA Private-key File

//Create File
unsigned long   RY3_CreateFile(RY_HANDLE handle, unsigned short FileID, int Size, int Type);

//Write File
unsigned long   RY3_WriteFile(RY_HANDLE handle, unsigned short FileID, int offset, unsigned char* pbuf, int Size);

//Execute File
unsigned long   RY3_ExecuteFile(RY_HANDLE handle, unsigned short FileID, unsigned char* pInBuf, int InSize, unsigned char* pOutBuf, int* pOutSize);

//Delete all File
unsigned long   RY3_EraseAllFile(RY_HANDLE handle);

//Generate RSA Public-key and Private-key(kid:0-8, (0:Public-key and Private-key for Update , 1-8:General Public-key and Private-key))
//pPubBakup:Output 140 bytes Public-key for backup
//pPriBakup  :Output 340 bytes Private-key for backup
//pPubBakup=NUll or pPriBakup=Null:not backup
unsigned long   RY3_GenRsaKey(RY_HANDLE handle, int kid, unsigned char* pPubBakup, unsigned char* pPriBakup);

//Set RSA Public-key and Private-key(kid:0-8, (0:Public-key and Private-key for Update , 1-8:General Public-key and Private-key))
//pPubKey:Input 140 bytes Public-key for Write
//pPriKey  :Input 340 bytes Private-key for Write
//pPubKey=NULL or pPriKey=NULL:not write 
unsigned long   RY3_SetRsaKey(RY_HANDLE handle, int kid, unsigned char* pPubKey, unsigned char* pPriKey);

//Public-key Encrypt (kid:1-8)
//length of input data must is 128 or 128 integer times
unsigned long   RY3_PublicEncrypt(RY_HANDLE handle, int kid, unsigned char* pBuf, int len);

//Private-key Decrypt(kid:1-8)
//length of input data must is 128 or 128 integer times
unsigned long   RY3_PrivateDecrypt(RY_HANDLE handle, int kid, unsigned char* pBuf, int len);

//MD5 algorithm
unsigned long   RY3_MD5(RY_HANDLE handle, unsigned char* pBuf, int len, unsigned char* pMD5);

//SHA1 algorithm
unsigned long   RY3_SHA1(RY_HANDLE handle, unsigned char* pBuf, int len, unsigned char* pSHA1);

//Set key for 3DES Encrypt and decrypt,Length of key:16 bytes, (kid:1-8)
unsigned long   RY3_Set3DESKey(RY_HANDLE handle, int kid, unsigned char* pKey);

#define FLAG_ENCODE  0 //Encrypt
#define FLAG_DECODE  1 //decrypt

//(3DES Encrypt and decrypt(kid:1-8))
//length of input must is 8 or 8 integer times
unsigned long   RY3_3DES(RY_HANDLE handle, int kid, int flag, unsigned char* pBuf, int len);

//update
unsigned long   RY3_Update(RY_HANDLE handle, unsigned char* pbuf, int len);

#define Data_TYPE_PubKey		0   //Public-key
#define Data_TYPE_PriKey		1   //Private-key
#define Data_TYPE_3DesKey	2   //(3DES key)
#define Data_TYPE_Memory		3   //8192 bytes data area

//Generate update Data Packet
//pLicSN:sn,pLicSN=NULL:unlimited
//type:Data type of update
//kid_offset: offset or kid of update(1-8(kid),type=Data_TYPE_Memory:offset of 8192 Data area)
//pbuf:      Address for Update
//len:        length of update(len:140 bytes(Public-key),340 bytes(Private-key),16 bytes(ES-key))
//pUPubKey:  update public-key
//pOutData:   Output the update packet
//pOutLen:   Output length of update packet
unsigned long   RY3_GenUpdatePacket(RY_HANDLE handle, char* pLicSN, int type, int kid_offset, unsigned char* pbuf, int len, unsigned char* pUPubKey, unsigned char* pOutData, int* pOutLen);

#ifdef __cplusplus 
}
#endif

#endif	//__FT_RY3_HEADER_H
