#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "RY3_API.h"
#include "ETToken.h"
#include <sys/types.h> 
#include <sys/stat.h> 
#include <unistd.h>
#include <fcntl.h> 

#define TRUE 1
#define FALSE 0
extern int m_etnum;
extern struct ET_Device_Descript        m_etlist[32];
RY_HANDLE  handle = 0;
static int   count = 0;
static int finded = 0;
static int opened = 0;
static char  vendorbuf[16];
static char  pinbuf[32];

static char  vendorIDseed[256];

static unsigned char  pub_buf[140];
static unsigned char  pri_buf[340];

int GetFileSize(int fd)
{
        struct stat stmp;
        if (fstat(fd, &stmp) < 0)
        return -1;
        return stmp.st_size;
}


void ShowBinHex(unsigned char* pBin, int len)
{
	// Show 16 bytes each line.
	int  i, j ,k, kk;
	int  lLines = len / 16;
	int  lCharInLastLine = 0;
	//
	if(0 != len % 16)
	{
		lCharInLastLine = len - lLines * 16;
	}

	for(i = 0; i < lLines; ++i)
	{
		for(j = 0; j < 16; ++j)
		{
			printf("%02X ", pBin[16 * i + j]);

			if(j == 7)
				printf("- ");
		}

		printf("    ");

/*		for(j = 0; j < 16; ++j)
		{
			if(isprint(pBin[16 * i + j]))
				printf("%c", pBin[16 * i + j]);
			else
				printf(".");
		}*/

		printf("\n");
	}

	if(0 != lCharInLastLine)
	{
		for(j = 0; j < lCharInLastLine; ++j)
		{
			printf("%02X ", pBin[16 * i + j]);

			if(j == 7 && lCharInLastLine > 8)
				printf("- ");
		}

		k = 0;

		k += ((16 - lCharInLastLine) * 3);

		if(lCharInLastLine <= 8)
		{
			k += 2;
		}

		for(kk = 0; kk < k; ++kk)
			printf(" ");

		printf("    ");

	/*	for(j = 0; j < lCharInLastLine; ++j)
		{
			if(isprint(pBin[16 * i + j]))
				printf("%c", pBin[16 * i + j]);
			else
				printf(".");
		}*/

		printf("\n");
	}
	printf("\n");
}

//================================================

unsigned long FindRY3()
{
    unsigned long retcode;
	
	

	printf("Find Rockey3...\n");
	count = 0;
	retcode = RY3_Find(vendorbuf, &count);
	if(retcode == RY3_NOT_FOUND)
	{
		printf("\nRockey3 not found.\n");
		return retcode;
	}
	if(retcode == RY3_INVALID_PARAMETER)
	{
		printf("\nWrong VendorID.\n");
		return retcode;
	}
	finded = 1;
	printf("Find Rockey3 success.\n");
	
	return retcode;
}

unsigned long OpenRY3(int num)
{
    	unsigned long retcode;
	int i;
	printf("Open Rockey3...\n");
	/*
	if(finded == 0)
	{
		printf("\nPlease [F]ind Rockey3 first.\n");
		return  -1;
	}
	*/
	retcode = RY3_Open(&handle, num);
	
	if(retcode != RY3_SUCCESS)
	{
		printf("\nOpen Rockey3 failed.\n");
		return retcode;
	}
	opened = 1;
	printf("Open Rockey3 success.\n");
	return retcode;
	//    printf("\r\nRY3_Open() retcode=%08X\r\n", retcode);
}

void Exit()
{
  int n;
	unsigned long retcode;
	printf("Close Rockey3...\n");
	if(opened == 0)
	{
	  printf("Rockey3 is not opened.\n");
		
	  printf("Press Enter to quit!\r\n");
  
	  n=getchar();
	  if(n==10){
		  getchar();
	  }

		return;
	}
       		retcode = RY3_Close(handle, TRUE);
		if(retcode != 0)
		{
			printf("Close Rockey3 failed.\n");
			printf("Press Enter to quit!\r\n");
  
		        n=getchar();
			if(n==10){
			  getchar();
			}
		}
		opened = 0;
		printf("Close Rockey3 success.\n");
	//
//	finded = 0;
	handle = 0;
	printf("Press Enter to quit!\r\n");
  
        n=getchar();
	  if(n==10){
		  getchar();
	  }
	//    
//    printf("\r\nRY3_Close() retcode=%08X\r\n", retcode);
}

unsigned long GetHardInfo()
{
	unsigned long retcode;
	int   size;
	char  buf[32];
	//
	printf("GetHardInformation...\n");
	
	//================================================
	memset(buf, 0, sizeof(buf));
    	retcode = RY3_GetHardID(handle, buf);
	if(retcode != 0)
	{
		printf("GetHardID failed.\n");
		return retcode;
	}
	printf("GetHardID success.\n");
	printf("sn=%s\n",buf);
//	printf("\r\nRY3_GetHardID() retcode=%08X sn=%s\r\n", retcode, buf);
	//
	
	retcode = RY3_GetFreeSize(handle, &size);
	if(retcode != 0)
	{
		printf("GetFreeSize failed.\n");
		return retcode;
	}
	printf("GetFreeSize success.\n");
	printf("size=%d\n",size);
	return retcode;
//	printf("\r\nRY3_GetFreeSize() retcode=%08X size=%d\r\n", retcode, size);
}

unsigned long SetVendorID()
{
	unsigned long retcode;
	char  bufID[16];
	
	printf("SetVendorID...\n");
	
	
//==============================================

	memset(bufID,0,sizeof(bufID));
	retcode = RY3_SetVendorID(handle, vendorIDseed, strlen(vendorIDseed), bufID);
	if(retcode != RY3_SUCCESS)
	{
		if(retcode == RY3_DEVPIN_NOT_CHECK)
		{
			printf("SetVendorID failed.Please [V]erifyDevPin first.\n");
			return retcode;
		}
		printf("SetVendorID failed.\n");
		return retcode;
	}
	memset(vendorbuf, 0, sizeof(vendorbuf));
	memcpy(vendorbuf,bufID,sizeof(bufID));
	printf("SetVendorID success.\n");
	printf("New VendorID=%s.(Please remember the New VendorID!)\n",bufID);
	return retcode;
}

unsigned long GenRandoM()
{
	unsigned long retcode;
	int   len_need;
	unsigned char  buf[128];

	printf("GenRandom...\n");
	
	len_need = 16;
	memset(buf, 0, sizeof(buf));
    	retcode = RY3_GenRandom(handle, len_need, buf);
	if(retcode != 0)
	{
		printf("\nGenRandom failed.\n");
		return retcode;
		
	}
	printf("GenRandom success.\n");
	printf("Random:\n");
	ShowBinHex(buf, len_need);
	return retcode;
	//
//	printf("\r\nRY3_GenRandom() retcode=%08X\r\n", retcode);
    
}

unsigned long VerifyDevPin()
{
	unsigned long retcode;
	int   RemainCount;
	//
	printf("Verify DeveloperPIN...\n");

//==================================================
	RemainCount = 0;
   	retcode = RY3_VerifyDevPin(handle, pinbuf, &RemainCount);
	if(retcode != 0)
	{
		printf("\nVerify DeveloperPIN failed.\n");
		return retcode;
	}
	printf("Verify DeveloperPIN success.\n");
	return retcode;
//	printf("\r\nRY3_VerifyDevPin() retcode=%08X  RemainCount=%d\r\n", retcode, RemainCount);
}

unsigned long GenRsaKey()
{
    unsigned long retcode;
	int   keyid;
	
	char  buf[16];
	
	//
	printf("GenRsaKey...\n");	
//=======================================================
	keyid = 1;
	memset(pub_buf, 0, sizeof(pub_buf));
    	memset(pri_buf, 0, sizeof(pri_buf));
	retcode = RY3_GenRsaKey(handle, keyid, pub_buf, pri_buf);
	if(retcode != 0)
	{
		if(retcode == RY3_INVALID_PARAMETER)
		{
			printf("\nGenRsaKey failed(invalid parameter).\n");
			return retcode;
		}
		if(retcode == RY3_DEVPIN_NOT_CHECK)
		{
			printf("\nGenRsaKey failed.Please [V]erifyDevPin first.\n");
			return retcode;
		}
		printf("\nGenRsaKey failed.\n");
		return retcode;
	}
	printf("GenRasKey success.\n");
    	printf("Public Key:\r\n"); 
    	ShowBinHex(pub_buf, 140);

	printf("Private Key:\r\n"); 
	ShowBinHex(pri_buf, 340);
	return retcode;
}

unsigned long memorytest()
{
    unsigned long retcode;
	int   offset;
	
	unsigned char  len;
	char  buf[16];
	unsigned char  bin_buf[128];	
	int i;
	//
	printf("MemoryTest...\n");

	offset = 0;
	len = 128;
    	printf("Gen data for write:\n");
		
	for(i=0; i < len; i++)
	{
        	bin_buf[i] = (unsigned char)i;
	}
	ShowBinHex(bin_buf, len);
	//	
	printf("RY3_Write...\n");
	retcode = RY3_Write(handle, offset, bin_buf, len);
	if(retcode != 0)
	{
		printf("\nRY3_Write failed.\n");
		return retcode;
	}
	printf("RY3_Write success.\n");
	printf("RY3_Write:\n");
	ShowBinHex(bin_buf, len);
	
	printf("RY3_Read...\n");
    	memset(bin_buf, 0, sizeof(bin_buf));
	retcode = RY3_Read(handle, offset, bin_buf, len);
	if(retcode != 0)
	{
		printf("RY3_Read failed.\n");
		return retcode;
	}
	printf("RY3_Read success.\n");
	printf("RY3_Read:\n");
	ShowBinHex(bin_buf, len);

	printf("RY3_Read(7168)...\n");
    	memset(bin_buf, 0, sizeof(bin_buf));
	retcode = RY3_Read(handle, 7168, bin_buf, 16);
	if(retcode != 0)
	{
		printf("RY3_Read(7168) failed.\n");
		return retcode;
	}
	printf("RY3_Read(7168) success.\n");
	printf("RY3_Read(7168) :\n");
    	ShowBinHex(bin_buf, 16);
	return retcode;
}

unsigned long sharetest()
{
    unsigned long retcode;
	int   offset;
	unsigned char  len;
	char  buf[16];
	unsigned char  bin_buf[32];	
	int i;
	
	//
	printf("ShareTest...\n");

	offset = 0;
	len = 32;
    	printf("Gen data for write: \r\n");
	for(i=0; i<len; i++)
	{
        	bin_buf[i] = (unsigned char)i;
	}
	ShowBinHex(bin_buf, len);
	//
	printf("RY3_WriteShare...\n");
	retcode = RY3_WriteShare(handle, offset, bin_buf, len);
	if(retcode != 0)
	{
		if(retcode == RY3_INVALID_PARAMETER)
		{
			printf("RY3_WriteShare failed(Invalid Parameter).\n");
			return retcode;
		}
		printf("RY3_WriteShare failed.\n");
		return retcode;
	}
	printf("RY3_WriteShare success.\n");
	printf("RY3_WriteShare:\n");
	ShowBinHex(bin_buf, len);

	printf("RY3_ReadShare...\n");
	memset(bin_buf, 0, sizeof(bin_buf));
	retcode = RY3_ReadShare(handle, offset, bin_buf, len);
	if(retcode != 0)
	{
		printf("RY3_ReadShare failed.\n");
		return retcode;
	}
	printf("RY3_ReadShare success.\n");
	printf("RY3_ReadShare:\n");
    	ShowBinHex(bin_buf, len);
	return retcode;
}

unsigned long filetest()
{
	unsigned long  retcode;
	 int  hFile;
	int    FileSize;
	unsigned long  bytesread;
	unsigned char   FileBuff[1024];
	int    OutSize;
	
	unsigned char   InBuf[128];
	unsigned char   OutBuf[128];
	//
	printf("FileTest...\n");

	
//=======================================================
	RY3_EraseAllFile(handle);

	printf("RY3_CreateFile(FILE_TYPE_EXE)...\n");
    	retcode = RY3_CreateFile(handle, 0x0001, 1024, FILE_TYPE_EXE);
	if(retcode != 0)
	{
		if(retcode == RY3_DEVPIN_NOT_CHECK)
		{
			printf("\nRY3_CreateFile(FILE_TYPE_EXE) failed.Please [V]erifyDevPin first.\n");
			return retcode;
		}
		printf("RY3_CreateFile(FILE_TYPE_EXE) failed.\n");
		return retcode;
	}
	printf("RY3_CreateFile(FILE_TYPE_EXE) success.\n");

	printf("RY3_CreateFile(FILE_TYPE_DATA)...\n");
	retcode = RY3_CreateFile(handle, 0x0002, 1024, FILE_TYPE_DATA);
	if(retcode != 0)
	{
		printf("RY3_CreateFile(FILE_TYPE_DATA) failed.\n");
		return retcode;
	}
	printf("RY3_CreateFile(FILE_TYPE_DATA) success.\n");

	printf("RY3_CreateFile(FILE_TYPE_RSA_PUBLIC)...\n");
	retcode = RY3_CreateFile(handle, 0x0003, 1024, FILE_TYPE_RSA_PUBLIC);
	if(retcode != 0)
	{
		printf("RY3_CreateFile(FILE_TYPE_RSA_PUBLIC) failed.\n");
		return retcode;
	}
	printf("RY3_CreateFile(FILE_TYPE_RSA_PUBLIC) success.\n");

	printf("RY3_CreateFile(FILE_TYPE_RSA_PRIVATE)...\n");
	retcode = RY3_CreateFile(handle, 0x0004, 1024, FILE_TYPE_RSA_PRIVATE);
	if(retcode != 0)
	{
		printf("RY3_CreateFile(FILE_TYPE_RSA_PRIVATE) failed.\n");
		return retcode;
	}
	printf("RY3_CreateFile(FILE_TYPE_RSA_PRIVATE) success.\n");


	printf("RY3_WriteFile(FILE_TYPE_EXE)...\n");
	hFile = open("hardware.c51",O_RDONLY);
	if(hFile == -1)
	{
		printf("open file hardware.c51 error %X\n");
		return retcode;
	}
	//
	FileSize = GetFileSize(hFile);
	if(FileSize > 1024)
	{
		printf("\r\nFile size too large!\r\n");
		close(hFile);
		return retcode;
	}
    //
	read(hFile,FileBuff,FileSize);
	close(hFile);
    //
	retcode = RY3_WriteFile(handle, 0x0001, 0, FileBuff, FileSize);
	if(retcode != 0)
	{
		printf("RY3_WriteFile(FILE_TYPE_EXE) failed.\n");
		return retcode;
	}
	printf("RY3_WriteFile(FILE_TYPE_EXE) success.\n");

	printf("RY3_ExecuteFile(FILE_TYPE_EXE)...\n");
	OutSize = sizeof(OutBuf);
	memset(InBuf, 0, sizeof(InBuf));
	memset(OutBuf, 0, sizeof(OutBuf));
	//
	*((unsigned short*)InBuf) = 8;  // 8!
    	retcode = RY3_ExecuteFile(handle, 0x0001, InBuf, 2, OutBuf, &OutSize);
	if(retcode != 0)
	{
		printf("RY3_ExecuteFile(FILE_TYPE_EXE) failed.\n");
		return retcode;
	}
	printf("RY3_ExecuteFile(FILE_TYPE_EXE) success.\n");
	printf("RY3_ExecuteFile(FILE_TYPE_EXE) result: 8! = %ld\n",*((unsigned long*)OutBuf));
   
    	printf("EraseAllFile...\n");
	retcode = RY3_EraseAllFile(handle);
	if(retcode != 0)
	{
		printf("EraseAllFile failed.\n");
		return retcode;
	}
	printf("EraseAllFile success.\n");
	return retcode;
}

unsigned long rsatest()
{
    unsigned long retcode;
	int   keyid;
	char  buf[16];
	unsigned char  bin_buf[128];
	int i;
	
	
	printf("RsaTest...\n");
	
//=======================================================
	keyid = 1;
	
    	
    	printf("Gen data for test: \r\n");
	for(i=0; i<sizeof(bin_buf); i++)
	{
        bin_buf[i] = i;
	}
	ShowBinHex(bin_buf, sizeof(bin_buf));
	
	//===============================================
	printf("RY3_PublicEncrypt...\n");
    	retcode = RY3_PublicEncrypt(handle, keyid, bin_buf, 128);
	if(retcode != 0)
	{
		printf("RY3_PublicEncrypt failed.\n");
		return retcode;
	}
	printf("RY3_PublicEncrypt success.\n");
    	printf("PublicEncrypt result:\n");
	ShowBinHex(bin_buf, sizeof(bin_buf));
	
	//===============================================
	printf("RY3_PrivateDecrypt...\n");
    	retcode = RY3_PrivateDecrypt(handle, keyid, bin_buf, 128);
	if(retcode != 0)
	{
		printf("RY3_PrivateDecrypt failed.\n");
		return retcode;
	}
	printf("RY3_PrivateDecrypt success.\n");
    	printf("PrivateDecrypt result:\n");
	ShowBinHex(bin_buf, sizeof(bin_buf));
	return retcode;
 
}

unsigned long signtest()
{
    unsigned long retcode;
	unsigned char  bin_buf[128];
	unsigned char  signbuf[32];	
	int i;
	
    //
    	printf("SignTest...\n");
    	
	
//=======================================================
    	printf("Gen data for test: \r\n");
	for(i=0; i<sizeof(bin_buf); i++)
	{
        bin_buf[i] = i;
	}
	ShowBinHex(bin_buf, sizeof(bin_buf));
	//
	memset(signbuf, 0, sizeof(signbuf));
	printf("RY3_MD5...\n");
	retcode = RY3_MD5(handle, bin_buf, sizeof(bin_buf), signbuf);
	if(retcode != 0)
	{
		printf("RY3_MD5 failed.\n");
		return retcode;
	}
	printf("RY3_MD5 success.\n");
	printf("RY3_MD5:\n");
	ShowBinHex(signbuf, 16);
	//
    	memset(signbuf, 0, sizeof(signbuf));
	printf("RY3_SHA1...\n");
	retcode = RY3_SHA1(handle, bin_buf, sizeof(bin_buf), signbuf);
	if(retcode != 0)
	{
		printf("RY3_SHA1 failed.\n");
		return retcode;
	}
	printf("RY3_SHA1 success.\n");
	printf("RY3_SHA1:\n");
	ShowBinHex(signbuf, 32);
	return retcode;
}

unsigned long des3()
{
    unsigned long retcode;
	int   keyid;
	char  buf[16];
	unsigned char  bin_buf[128];
	int i;
	
	//
	printf("3DES...\n");
	
	
//=======================================================
	keyid = 1;
    	printf("Gen data for test: \r\n");
	for(i=0; i<sizeof(bin_buf); i++)
	{
        bin_buf[i] = i;
	}
	ShowBinHex(bin_buf, sizeof(bin_buf));
	//=========================================================
	retcode = RY3_3DES(handle, keyid, FLAG_ENCODE, bin_buf, sizeof(bin_buf));
	if(retcode != 0)
	{
		printf("RY3_3DES(FLAG_ENCODE) failed.\n");
		return retcode;
	}
	printf("RY3_3DES(FLAG_ENCODE) success.\n");
    	printf("3DES Encode result:\n");
	ShowBinHex(bin_buf, sizeof(bin_buf));
	
	//=========================================================
    	retcode = RY3_3DES(handle, keyid, FLAG_DECODE, bin_buf, sizeof(bin_buf));
	if(retcode != 0)
	{
		printf("RY3_3DES(FLAG_DECODE) failed.\n");
		return retcode;
	}
	printf("RY3_3DES(FLAG_DECODE) successs.\n");
    	printf("3DES Decode result:\n");
	ShowBinHex(bin_buf, sizeof(bin_buf));
	return retcode;
}

unsigned long setrsakey()
{
    unsigned long  retcode;
	int    keyid;
	int hFile;
	unsigned long  bytesread;
	char   buf[16];
	
	//
	printf("SetRsaKey...\n");
	
	keyid = 1;
	//==============
    	retcode = RY3_SetRsaKey(handle, keyid, pub_buf, pri_buf);
	if(retcode != 0)
	{
		if(retcode == RY3_DEVPIN_NOT_CHECK)
		{
			printf("\nSetRsaKey failed.Please [V]erifyDevPin first.\n");
			return retcode;
		}
		printf("\nSetRsaKey failed.\n");
		return retcode;
	}
	printf("SetRsaKey success.\n");
	memset(pub_buf, 0, sizeof(pub_buf));
    	memset(pri_buf, 0, sizeof(pri_buf));
	return retcode;
}

unsigned long seteskey()
{
    unsigned long retcode;
	int   keyid;
	char  buf[16];
	unsigned char  key_buf[16];
	int i;
	
	printf("Set3DESKey...\n");
	
	keyid = 1;
    //
    	printf("Gen key for test: \r\n");
	for(i=0; i<sizeof(key_buf); i++)
	{
        key_buf[i] = i;
	}
	ShowBinHex(key_buf, sizeof(key_buf));
	//
	retcode = RY3_Set3DESKey(handle, keyid, key_buf);
	if(retcode != 0)
	{
		if(retcode == RY3_DEVPIN_NOT_CHECK)
		{
			printf("\nSet3DESKey failed.Please [V]erifyDevPin first.\n");
			return retcode;
		}
		printf("\nSet3DESKey failed.\n");
		return retcode;
	}
	printf("Set3DESKey success.\n");
	return retcode;
}


int main(int argc, char* argv[])
{
	int i;
	int num = 0;
	unsigned long retcode;
	int n;
	printf("Please input VendorID of the first Rockey3 (8 char) : \n");
	memset(vendorbuf,0,sizeof(vendorbuf));
	scanf("%s",vendorbuf);
	if( strlen(vendorbuf) > 8)
	{
		printf("Wrong VendorID!\n");
		printf("Press Enter to quit!\r\n");
  
		n=getchar();
		if(n==10){
		  getchar();
		}
		return 0;
	}
	printf("Please input DeveloperPIN of the first Rockey3 (24 char) :\n");
	memset(pinbuf,0,sizeof(pinbuf));
	fflush(stdin);
	scanf("%s",pinbuf);
	if( strlen(pinbuf) > 24)
	{
		printf("Wrong DeveloperPIN!\n");
		printf("Press Enter to quit!\r\n");
  
		n=getchar();
		if(n==10){
		  getchar();
		}
		return 0;
	}

	//Find Rockey3
	printf("\n");
	retcode = FindRY3();
	if(retcode != RY3_SUCCESS){
	  printf("Press Enter to quit!\r\n");
  
	  n=getchar();
	  if(n==10){
		  getchar();
	  }
	  return 0;
	}
	//Open Rockey3
	printf("\n");
	for(num=1; num<=count; num++)
	{
	    	retcode = OpenRY3(num);
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}

		//VerifyDevPin
		printf("\n");
		retcode = VerifyDevPin();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}

		//Set the VendorID
		printf("\n");
		for(i=0;i<6;i++)
		{
			vendorIDseed[i] = '1'+ i;
		}
		retcode = SetVendorID();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}

		//Get Hardware Information
		printf("\n");
		retcode =GetHardInfo();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}

		//Get the Random
		printf("\n");
		retcode = GenRandoM();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}
		
		printf("\n");
		//Memorytest: offset+len <= 7168
		retcode = memorytest();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}

		// Sharetest:offset + len <= 32
		retcode = sharetest();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}

		//FileTest:Creat File,Write File,Execute File,erase file.
		retcode = filetest();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}

		//get rsa key
		printf("\n");
		retcode = GenRsaKey();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}

		//set rsa key
		retcode = setrsakey();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}


		//set 3deskey
		retcode = seteskey();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}


		//rsa test
		printf("\n");
		retcode = rsatest();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}

		// 3des test 
		retcode = des3();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}

		// md5,sha1 test
		retcode = signtest();
		if(retcode != RY3_SUCCESS){
		  printf("Press Enter to quit!\r\n");
  
		  n=getchar();
		  if(n==10){
		    getchar();
		  }
		  return 0;
		}

		Exit();
	}
	return 0;
}
 


